# TODOs

## for publishing

## for the future
* Find out if we can use the settings for anything useful and include if any VS Code settings are added through the `contributes.configuration` extension point in the README.md
* The `Definition of a Parameter (for procedures and functions)` part of one restriction could maybe be alleviated by using "begin+end" style rule for parameter definitions in procedure and function definitions. However then the behavior would be different from the other cases (`START`, `EXECUTE` etc.) so it might be better to keep this restriction for consistency.
* Add hovers to all the normal commands and the API commands (and possibly common variables set by message port api commands?) showing some documentation about them. Maybe it can be implemented using `Programmatic Language Features`.
* Auto-completion for the known commands and API commands. Maybe also for the known variables (local, global, normal ones provided by AdoScript). Maybe it can be implemented using `Programmatic Language Features`.
* Maybe provide an outline with all available procedures (and functions?) from all script files in "the Project". Maybe it can be implemented using `Workbench Extensions`, more specifically the `TreeView API`.
* Wanted to add an icon for the languages covered by this extension, but iconThemes have to be explicitly selected by the user and can't simply extend (all of the) existing themes yet (see issue https://github.com/Microsoft/vscode/issues/14662 accessed at 28.04.2019). Same goes for color and style themes for the different scopes (can't extend existing themes to cover new scopes).

## For programmatic extension
* The following devDependencies for package.json MIGHT be necessary at some point, so keeping them here so it's easy to copy:
```
  "typescript": "^3.3.1",
  "vscode": "^1.1.28",
  "tslint": "^5.12.1",
  "@types/node": "^10.12.21",
  "@types/mocha": "^2.2.42"
```